package com.heyu.api.controller.mm;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.heyu.api.alibaba.request.mm.VvActivityRequest;
import com.heyu.api.common.annotation.Describe;
import com.heyu.api.data.dao.vv.VvActivityDao;
import com.heyu.api.data.utils.R;
import com.heyu.api.utils.ISelect;
import com.heyu.api.utils.PPageUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Slf4j
@RestController
@RequestMapping("/mm/activity")
public class AdminActivityController {


    @Autowired
    private VvActivityDao vvActivityDao;


    /***
     * 奖励 列表
     * http://localhost:8888/mm/activity/list
     */
    @Describe("活动列表")
    @RequestMapping("/list")
    public R list(@RequestBody VvActivityRequest vvActivityRequest) {

        PPageUtils pageUtils = PPageUtils.startPage(vvActivityRequest.getPageNum(), vvActivityRequest.getPageSize())
                .doSelect(new ISelect() {
                    @Override
                    public List doSelect(IPage page) {
                        return vvActivityDao.selectByCondition(page,
                                vvActivityRequest.getActivityName(),
                                vvActivityRequest.getMinCreateTimestamp(),
                                vvActivityRequest.getMaxCreateTimestamp(),
                                vvActivityRequest.getCreateTimestampSort()
                        );
                    }
                });
        return R.ok().setData(pageUtils);
    }

}
